local Sackville = LibStub("AceAddon-3.0"):GetAddon("Sackville")
local B = LibStub("LibBabble-Inventory-3.0")
local BL = B:GetLookupTable()

Sackville.Options = {}

local sep = "\001"

Sackville.Options.categories = {
    [BL["Armor"]] = {
        {   filterPath = BL["Armor"] }
    },
    [BL["Consumable"]] = {
        {   filterPath = "Consumable" }
    },
    [BL["Weapon"]] = {
        {   filterPath = BL["Weapon"] }
    },
    [BL["Trinket"]] = {
        {   filterPath = "Equipment" .. sep .. BL["Trinket"] }
    },
    [BL["Tabard"]] = {
        {   filterPath = "Equipment" .. sep .. BL["Tabard"] }
    },
    [BL["Food & Drink"]] = {
        {   filterPath = BL["Consumable"] .. sep .. BL["Food & Drink"] }
    },
    [BL["Potion"]] = {
        {   filterPath = BL["Consumable"] .. sep .. BL["Potion"] }
    },
    [BL["Elixir"]] = {
        {   filterPath = BL["Consumable"] .. sep .. BL["Elixir"] }
    },
    [BL["Flask"]] = {
        {   filterPath = BL["Consumable"] .. sep .. BL["Flask"] }
    },
    [BL["Scroll"]] = {
        {   filterPath = BL["Consumable"] .. sep .. BL["Scroll"] }
    },
    [BL["Bandage"]] = {
        {   filterPath = BL["Consumable"] .. sep .. BL["Bandage"] }
    },
    [BL["Metal & Stone"]] = {
        {   filterPath = BL["Trade Goods"] .. sep .. BL["Metal & Stone"] }
    },
    [BL["Jewelcrafting"]] = {
        {   filterPath = BL["Trade Goods"] .. sep .. BL["Jewelcrafting"],
            operation = "or"
        },
        {   filterPath = BL["Gem"],
            operation = "or"
        }
    },
    [BL["Enchanting"]] = {
        {   
            filterPath = BL["Trade Goods"] .. sep .. BL["Enchanting"],
            operation = "or"
        },
        {
            filterPath = BL["Trade Goods"] .. sep .. BL["Weapon Enchantment"],
            operation = "or"
        },
        {
            filterPath = BL["Trade Goods"] .. sep .. BL["Armor Enchantment"],
            operation = "or"
        }
    },
    [BL["Trade Goods"]] = {
        {   filterPath = BL["Trade Goods"] }
    },
    [BL["Cloth"]] = {
        {   filterPath = BL["Trade Goods"] .. sep .. BL["Cloth"] }
    },
    [BL["Parts"]] = {
        {   filterPath = BL["Trade Goods"] .. sep .. BL["Parts"] }
    },
    [BL["Elemental"]] = {
        {   filterPath = BL["Trade Goods"] .. sep .. BL["Elemental"] }
    },
    [BL["Herb"]] = {
        {   filterPath = BL["Trade Goods"] .. sep .. BL["Herb"] }
    },
    [BL["Leather"]] = {
        {   filterPath = BL["Trade Goods"] .. sep .. BL["Leather"] }
    },
    [BL["Devices"]] = {
        {   filterPath = BL["Trade Goods"] .. sep .. BL["Devices"] }
    },
    [BL["Cooking"]] = {
        {   filterPath = BL["Trade Goods"] .. sep .. BL["Cooking"] }
    },
    [BL["Quest"]] = {
        {   filterPath = BL["Quest"] .. sep .. BL["Quest"] }
    },
    [BL["Reagent"]] = {
        {   filterPath = BL["Miscellaneous"] .. sep .. BL["Reagent"] }
    },
    [BL["Junk"]] = {
        {   filterPath = "Quality" .. sep .. ITEM_QUALITY0_DESC }
    }
}

Sackville.Options.bagConfig = {
    ["Equipment"] = {
        name = "Equipment",
        displayOrder = 1,
        bagType = "player",
        defaultPriority = 2,
        sortCriteria = { 
            {
                key = "level",
                comparison = ">"
            },
            {
                key = "quality",
                comparison = ">"
            },
            {
                key = "name",
                comparison = "<"
            }        
        },
        sections = {
            [BL["Armor"]] = {
                name = BL["Armor"],
                displayOrder = 1,
                priority = 1,
                useDefaultPriority = false,
                useDefaultSorting = true,
                categories = { 
                    BL["Armor"]
                }
            },
            [BL["Weapon"]] = {
                name = BL["Weapon"],
                displayOrder = 2,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Weapon"]
                }
            },
            [BL["Trinket"]] = {
                name = BL["Trinket"],
                displayOrder = 3,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Trinket"]
                }
            },
            [BL["Tabard"]] = {
                name = BL["Tabard"],
                displayOrder = 4,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Tabard"]
                }
            }
        }
    },
    [BL["Consumable"]] = {
        name = BL["Consumable"],
        bagType = "player",
        defaultPriority = 2,
        displayOrder = 2,
        sortCriteria = { 
            {
                key = "minLevel",
                comparison = ">"
            },
            {
                key = "name",
                comparison = "<"
            },
            {
                key = "count",
                comparison = ">"
            }        
        },
        sections = {
            [BL["Food & Drink"]] = {
                name = BL["Food & Drink"],
                displayOrder = 1,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Food & Drink"]
                }
            },
            [BL["Flask"]] = {
                name = BL["Flask"],
                displayOrder = 2,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Flask"]
                }
            },
            [BL["Potion"]] = {
                name = BL["Potion"],
                displayOrder = 3,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Potion"]
                }
            },
            [BL["Elixir"]] = {
                name = BL["Elixir"],
                displayOrder = 4,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Elixir"]
                }
            },
            [BL["Scroll"]] = {
                name = BL["Scroll"],
                displayOrder = 5,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Scroll"]
                }
            },
            [BL["Bandage"]] = {
                name = BL["Bandage"],
                displayOrder = 6,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Bandage"]
                }
            },
            [BL["Other"]] = {
                name = BL["Other"],
                displayOrder = 7,
                priority = 1,
                useDefaultPriority = false,
                useDefaultSorting = true,
                categories = { 
                    BL["Consumable"]
                }
            }             
        }
    },
    [BL["Trade Goods"]] = {
        name = BL["Trade Goods"],
        displayOrder = 3,
        bagType = "player",
        defaultPriority = 2,
        sortCriteria = { 
            {
                key = "name",
                comparison = "<"
            },
            {
                key = "count",
                comparison = ">"
            }        
        },
        sections = {
            [BL["Metal & Stone"]] = {
                name = BL["Metal & Stone"],
                displayOrder = 1,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Metal & Stone"]
                }
            },
            [BL["Jewelcrafting"]] = {
                name = BL["Jewelcrafting"],
                displayOrder = 2,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = {
                    BL["Jewelcrafting"]
                }
            },
            [BL["Enchanting"]] = {
                name = BL["Enchanting"],
                displayOrder = 3,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Enchanting"]
                }
            },
            [BL["Cloth"]] = {
                name = BL["Cloth"],
                displayOrder = 4,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Cloth"]
                }
            },
            [BL["Parts"]] = {
                name = BL["Parts"],
                displayOrder = 5,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Parts"]
                }
            },
            [BL["Elemental"]] = {
                name = BL["Elemental"],
                displayOrder = 6,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Elemental"]
                }
            },
            [BL["Herb"]] = {
                name = BL["Herb"],
                displayOrder = 7,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Herb"]
                }
            },
            [BL["Leather"]] = {
                name = BL["Leather"],
                displayOrder = 8,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Leather"]
                }
            },
            [BL["Cooking"]] = {
                name = BL["Cooking"],
                displayOrder = 9,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Cooking"]
                }
            },
            [BL["Other"]] = {
                name = BL["Other"],
                displayOrder = 99,
                priority = 1,
                useDefaultPriority = false,
                useDefaultSorting = true,
                categories = { 
                    BL["Elemental"]
                }
            }         
        }
    },
    [BL["Other"]] = {
        name = BL["Other"],
        displayOrder = 4,
        bagType = "player",
        defaultPriority = 1,
        sortCriteria = { 
            {
                key = "name",
                comparison = "<"
            },
            {
                key = "count",
                comparison = ">"
            }        
        },
        sections = {
            [BL["Quest"]] = {
                name = BL["Quest"],
                displayOrder = 1,
                priority = 1,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Quest"]
                }
            },
            [BL["Reagent"]] = {
                name = BL["Reagent"],
                displayOrder = 2,
                priority = 1,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Reagent"]
                }
            },
            [BL["Devices"]] = {
                name = BL["Devices"],
                displayOrder = 3,
                priority = 1,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Devices"]
                }
            },
            [BL["Junk"]] = {
                name = BL["Junk"],
                displayOrder = 4,
                priority = 10,
                useDefaultPriority = false,
                useDefaultSorting = true,
                categories = { 
                    BL["Junk"]
                }
            },
            [BL["Other"]] = {
                name = BL["Other"],
                displayOrder = 5,
                priority = 0,
                useDefaultPriority = false,
                useDefaultSorting = true,
                alwaysMatch = true
            },
            ["Empty"] = {
                name = "Empty",
                displayOrder = 6,
                priority = 0,
                useDefaultPriority = true,
                useDefaultSorting = true,
                showEmptySlot = true,
                alwaysShow = true
            }            
        }
    },
    ["Bank Equipment"] = {
        name = "Bank Equipment",
        bagType = "bank",
        defaultPriority = 2,
        displayOrder = 5,
        sortCriteria = { 
            {
                key = "level",
                comparison = ">"
            },
            {
                key = "quality",
                comparison = ">"
            },
            {
                key = "name",
                comparison = "<"
            }        
        },
        sections = {
            [BL["Armor"]] = {
                name = BL["Armor"],
                displayOrder = 1,
                priority = 1,
                useDefaultPriority = false,
                useDefaultSorting = true,
                categories = { 
                    BL["Armor"]
                }
            },
            [BL["Weapon"]] = {
                name = BL["Weapon"],
                displayOrder = 2,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Weapon"]
                }
            },
            [BL["Trinket"]] = {
                name = BL["Trinket"],
                displayOrder = 3,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Trinket"]
                }
            },
            [BL["Tabard"]] = {
                name = BL["Tabard"],
                displayOrder = 4,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Tabard"]
                }
            }
        }
    },
    ["Bank Consumable"] = {
        name = "Bank Consumable",
        bagType = "bank",
        defaultPriority = 2,
        displayOrder = 6,
        sortCriteria = { 
            {
                key = "minLevel",
                comparison = ">"
            },
            {
                key = "name",
                comparison = "<"
            },
            {
                key = "count",
                comparison = ">"
            }        
        },
        sections = {
            [BL["Food & Drink"]] = {
                name = BL["Food & Drink"],
                displayOrder = 1,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Food & Drink"]
                }
            },
            [BL["Flask"]] = {
                name = BL["Flask"],
                displayOrder = 2,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Flask"]
                }
            },
            [BL["Potion"]] = {
                name = BL["Potion"],
                displayOrder = 3,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Potion"]
                }
            },
            [BL["Elixir"]] = {
                name = BL["Elixir"],
                displayOrder = 4,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Elixir"]
                }
            },
            [BL["Scroll"]] = {
                name = BL["Scroll"],
                displayOrder = 5,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Scroll"]
                }
            },
            [BL["Bandage"]] = {
                name = BL["Bandage"],
                displayOrder = 6,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Bandage"]
                }
            },
            [BL["Other"]] = {
                name = BL["Other"],
                priority = 1,
                displayOrder = 6,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Consumable"]
                }
            },              
        }
    },
    ["Bank Trade Goods"] = {
        name = "Bank Trade Goods",
        bagType = "bank",
        defaultPriority = 2,
        displayOrder = 7,
        sortCriteria = { 
            {
                key = "name",
                comparison = "<"
            },
            {
                key = "count",
                comparison = ">"
            }        
        },
        sections = {
            [BL["Metal & Stone"]] = {
                name = BL["Metal & Stone"],
                displayOrder = 1,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Metal & Stone"]
                }
            },
            [BL["Jewelcrafting"]] = {
                name = BL["Jewelcrafting"],
                displayOrder = 2,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = {
                    BL["Jewelcrafting"]
                }
            },
            [BL["Enchanting"]] = {
                name = BL["Enchanting"],
                displayOrder = 3,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Enchanting"]
                }
            },
            [BL["Cloth"]] = {
                name = BL["Cloth"],
                displayOrder = 4,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Cloth"]
                }
            },
            [BL["Parts"]] = {
                name = BL["Parts"],
                displayOrder = 5,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Parts"]
                }
            },
            [BL["Elemental"]] = {
                name = BL["Elemental"],
                displayOrder = 6,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Elemental"]
                }
            },
            [BL["Herb"]] = {
                name = BL["Herb"],
                displayOrder = 7,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Herb"]
                }
            },
            [BL["Leather"]] = {
                name = BL["Leather"],
                displayOrder = 8,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Leather"]
                }
            },
            [BL["Cooking"]] = {
                name = BL["Cooking"],
                displayOrder = 9,
                priority = 2,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Cooking"]
                }
            },
            [BL["Other"]] = {
                name = BL["Other"],
                displayOrder = 99,
                priority = 1,
                useDefaultPriority = false,
                useDefaultSorting = true,
                categories = { 
                    BL["Elemental"]
                }
            }         
        }
    },
    ["Bank Other"] = {
        name = "Bank Other",
        bagType = "bank",
        defaultPriority = 1,
        displayOrder = 8,
        sortCriteria = { 
            {
                key = "name",
                comparison = "<"
            },
            {
                key = "count",
                comparison = ">"
            }        
        },
        sections = {
            [BL["Quest"]] = {
                name = BL["Quest"],
                displayOrder = 1,
                priority = 1,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Quest"]
                }
            },
            [BL["Reagent"]] = {
                name = BL["Reagent"],
                displayOrder = 2,
                priority = 1,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Reagent"]
                }
            },
            [BL["Devices"]] = {
                name = BL["Devices"],
                displayOrder = 3,
                priority = 1,
                useDefaultPriority = true,
                useDefaultSorting = true,
                categories = { 
                    BL["Devices"]
                }
            },
            [BL["Junk"]] = {
                name = BL["Junk"],
                displayOrder = 4,
                priority = 10,
                useDefaultPriority = false,
                useDefaultSorting = true,
                categories = { 
                    BL["Junk"]
                }
            },
            [BL["Other"]] = {
                name = BL["Other"],
                displayOrder = 5,
                priority = 0,
                useDefaultPriority = false,
                useDefaultSorting = true,
                alwaysMatch = true
            },
            ["Empty"] = {
                name = "Empty",
                displayOrder = 6,
                priority = 0,
                useDefaultPriority = true,
                useDefaultSorting = true,
                showEmptySlot = true,
                alwaysShow = true
            }
        }
    }

}

Sackville.Options.layout = {}
Sackville.Options.layout.origin = {
    anchor = "BOTTOMRIGHT",
    x_offset = -3,
    y_offset = 90
}

Sackville.Options.BUTTON_SIZE = 40
Sackville.Options.FRAME_PADDING = 0
Sackville.Options.TITLE_EXTRA_WIDTH = 80

Sackville.Options.bagTypeList = { -- TODO: localize
    ["player"] = "player",
    ["bank"] = "bank"
}

Sackville.Options.itemSortOptionsList = {
    ["count"]           = "count",
    ["name"]            = "name",
    ["quality"]         = "quality",
    ["item level"]      = "level",
    ["required level"]  = "minLevel",
    ["equipped slot"]   = "equipSlot", -- TODO: add this to item
    ["item type"] = "type",
    ["item subType"] = "subType",
}

Sackville.Options.bag = {
    margin_left = 15,
    margin_right = 15,
    margin_top = 30,
    margin_bottom = 15,
    padding_left = 0,
    padding_right = 0,
    padding_top = 0,
    padding_bottom = 0,
    max_width = 400,
    min_width = 40,
    min_height = 135,
    title_height = 32,
    strata = "HIGH"
}

Sackville.Options.bag.backdrop = {
  -- path to the background texture
  bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark",  
  -- path to the border texture
  edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
  -- true to repeat the background texture to fill the frame, false to scale it
  tile = true,
  -- size (width or height) of the square repeating background tiles (in pixels)
  tileSize = 32,
  -- thickness of edge segments and square size of edge corners (in pixels)
  edgeSize = 22,
  -- distance from the edges of the frame to those of the background texture (in pixels)
  insets = {
    left = 6,
    right = 6,
    top = 6,
    bottom = 6
  }
}

Sackville.Options.bag.backdrop_bank = {
  -- path to the background texture
  -- bgFile = "Interface/Addons/Sackville/Textures/UI-Blue-Background",
  bgFile = 'Interface\\Addons\\Sackville\\Textures\\UI-Blue-Background.blp',
  -- path to the border texture
  edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
  -- true to repeat the background texture to fill the frame, false to scale it
  tile = true,
  -- size (width or height) of the square repeating background tiles (in pixels)
  tileSize = 32,
  -- thickness of edge segments and square size of edge corners (in pixels)
  edgeSize = 22,
  -- distance from the edges of the frame to those of the background texture (in pixels)
  insets = {
    left = 6,
    right = 6,
    top = 6,
    bottom = 6
  }
}

Sackville.Options.bag.backdrop_title = {
   bgFile = "Interface/WorldStateFrame/WorldStateFinalScoreFrame-TopBackground",  
   edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
   -- true to repeat the background texture to fill the frame, false to scale it
   tile = false,
   -- size (width or height) of the square repeating background tiles (in pixels)
   tileSize = 16,
   -- thickness of edge segments and square size of edge corners (in pixels)
   edgeSize = 22,
   -- distance from the edges of the frame to those of the background texture (in pixels)
   insets = {
      left = 6,
      right = 6,
      top = 6,
      bottom = 0
   }
}

Sackville.Options.section = {
    padding_left = 0,   -- unused
    padding_right = 10,
    padding_top = 0,    -- unused
    padding_bottom = 3,
    margin_left = 0,    -- unused
    margin_right = 0,   -- unused
    margin_top = 15,
    margin_bottom = 0,  -- unused
    min_height = Sackville.Options.BUTTON_SIZE + 20,
    title_height = 13
}

Sackville.Options.defaults = {
    profile = {
        bagConfig = Sackville.Options.bagConfig,
        categories = Sackville.Options.categories
    },
    char = {
        items = {},
        emptyItem = {}
    }
}